# Contributing to Tessera code

Thank you for your interest in contributing to our Tessera code. We welcome all meaningful contribution no matter the size.

If you'd like to contribute please send us a pull request with the change. We are very interactive and will respond immediately. 
Commits which do not comply with the coding standards and without substance are generally ignored/closed.

## What to contribute

We are happy for all contributions including:

 * Improved End to End Flow diagram
 * Documentation updates
 * Code contributions
 * Responding to other issues/supporting our community

Please refer our [Product Roadmap](http://docs.goquorum.com/en/latest/roadmap/) or [Issues](https://github.com/consensys/tessera/issues) for ideas to contribute.

## What makes a good contribution ?

 * Code must adhere to proper coding standards and self-documenting, easy to understand and explain
 * Follow standard [style guides](https://google.github.io/styleguide/javaguide.html).
 * Include test coverage (both unit and integration). Without 100 % test coverage the build will fail. All submissions must be testable in an automated fashion. 
 * If the change needs end to end testing with Quorum, please also contribute to our [Quorum acceptance Test suite](https://github.com/consensys/quorum-acceptance-tests).
 * Raise individual features/enhancements separately and do not bundle them as one big change.
 * Link each change to an issue (if it is new feature, please create an issue before contributing with the change)
 * Add proper commit messages and description of change in the request. 
 * Always add logging at appropriate level where applicable. 
 * Be proactive after submitting PR making sure all checks are passing

